[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# kafka

## Internal Telemetry

The following telemetry is emitted by this component.

### otelcol_kafka_broker_closed

The total number of connections closed.

Only produced when franz-go is enabled.

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| node_id | The Kafka node ID. | Any Int |

### otelcol_kafka_broker_connects

The total number of connections opened.

Only produced when franz-go is enabled.

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| node_id | The Kafka node ID. | Any Int |
| outcome | The operation outcome. | Str: ``success``, ``failure`` |

### otelcol_kafka_broker_throttling_duration

The throttling duration in ms imposed by the broker when receiving messages.

Only produced when franz-go is enabled.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ms | Histogram | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| node_id | The Kafka node ID. | Any Int |

### otelcol_kafka_receiver_bytes

The size in bytes of received messages seen by the broker.

Only produced when franz-go is enabled.

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| By | Sum | Int | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| node_id | The Kafka node ID. | Any Int |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |
| outcome | The operation outcome. | Str: ``success``, ``failure`` |

### otelcol_kafka_receiver_bytes_uncompressed

The uncompressed size in bytes of received messages seen by the client.

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| By | Sum | Int | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| node_id | The Kafka node ID. | Any Int |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |
| outcome | The operation outcome. | Str: ``success``, ``failure`` |

### otelcol_kafka_receiver_current_offset

Current message offset

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |

### otelcol_kafka_receiver_latency

The time it took in ms to receive a batch of messages.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| ms | Histogram | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| node_id | The Kafka node ID. | Any Int |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |
| outcome | The operation outcome. | Str: ``success``, ``failure`` |

### otelcol_kafka_receiver_messages

The number of received messages.

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| node_id | The Kafka node ID. | Any Int |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |
| outcome | The operation outcome. | Str: ``success``, ``failure`` |

### otelcol_kafka_receiver_offset_lag

Current offset lag

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |

### otelcol_kafka_receiver_partition_close

Number of finished partitions

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_kafka_receiver_partition_start

Number of started partitions

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

### otelcol_kafka_receiver_unmarshal_failed_log_records

Number of log records failed to be unmarshaled

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |

### otelcol_kafka_receiver_unmarshal_failed_metric_points

Number of metric points failed to be unmarshaled

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |

### otelcol_kafka_receiver_unmarshal_failed_spans

Number of spans failed to be unmarshaled

| Unit | Metric Type | Value Type | Monotonic |
| ---- | ----------- | ---------- | --------- |
| 1 | Sum | Int | true |

#### Attributes

| Name | Description | Values |
| ---- | ----------- | ------ |
| topic | The Kafka topic. | Any Str |
| partition | The Kafka topic partition. | Any Int |
