[comment]: <> (Code generated by mdatagen. DO NOT EDIT.)

# snowflake

## Default Metrics

The following metrics are emitted by default. Each of them can be disabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: false
```

### snowflake.database.bytes_scanned.avg

Average bytes scanned in a database over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.database.query.count

Total query count for database over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.query.blocked

Blocked query count for warehouse over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |

### snowflake.query.bytes_deleted.avg

Average bytes deleted in database over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.query.bytes_written.avg

Average bytes written by database over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.query.compilation_time.avg

Average time taken to compile query over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.query.executed

Executed query count for warehouse over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |

### snowflake.query.execution_time.avg

Average time spent executing queries in database over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.query.queued_overload

Overloaded query count for warehouse over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |

### snowflake.query.queued_provision

Number of compute resources queued for provisioning over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |

### snowflake.queued_overload_time.avg

Average time spent in warehouse queue due to warehouse being overloaded over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.queued_provisioning_time.avg

Average time spent in warehouse queue waiting for resources to provision over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.queued_repair_time.avg

Average time spent in warehouse queue waiting for compute resources to be repaired over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.storage.stage_bytes.total

Number of bytes of stage storage used by files in all internal stages (named, table, user).

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

### snowflake.storage.storage_bytes.total

Number of bytes of table storage used, including bytes for data currently in Time Travel.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

### snowflake.total_elapsed_time.avg

Average elapsed time over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| s | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

## Optional Metrics

The following metrics are not emitted by default. Each of them can be enabled by applying the following configuration:

```yaml
metrics:
  <metric_name>:
    enabled: true
```

### snowflake.billing.cloud_service.total

Reported total credits used in the cloud service over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {credits} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| service_type | Service type associated with metric query. | Any Str | false |

### snowflake.billing.total_credit.total

Reported total credits used across account over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {credits} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| service_type | Service type associated with metric query. | Any Str | false |

### snowflake.billing.virtual_warehouse.total

Reported total credits used by virtual warehouse service over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {credits} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| service_type | Service type associated with metric query. | Any Str | false |

### snowflake.billing.warehouse.cloud_service.total

Credits used across cloud service for given warehouse over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {credits} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |

### snowflake.billing.warehouse.total_credit.total

Total credits used associated with given warehouse over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {credits} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |

### snowflake.billing.warehouse.virtual_warehouse.total

Total credits used by virtual warehouse service for given warehouse over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {credits} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |

### snowflake.logins.total

Total login attempts for account over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| error_message | Error message reported by query if present. | Any Str | false |
| reported_client_type | Client type used for attempt. | Any Str | false |
| is_success | Login status (success or failure). | Any Str | false |

### snowflake.pipe.credits_used.total

Snow pipe credits contotaled over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {credits} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| pipe_name | Name of snowpipe. | Any Str | false |

### snowflake.query.bytes_spilled.local.avg

Average bytes spilled (intermediate results do not fit in memory) by local storage over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.query.bytes_spilled.remote.avg

Average bytes spilled (intermediate results do not fit in memory) by remote storage over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.query.data_scanned_cache.avg

Average percentage of data scanned from cache over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.query.partitions_scanned.avg

Number of partitions scanned during query so far over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.rows_deleted.avg

Number of rows deleted from a table (or tables) over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {rows} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.rows_inserted.avg

Number of rows inserted into a table (or tables) over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {rows} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.rows_produced.avg

Average number of rows produced by statement over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {rows} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.rows_unloaded.avg

Average number of rows unloaded during data export over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {rows} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.rows_updated.avg

Average number of rows updated in a table over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| {rows} | Gauge | Double |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| schema_name | Name of schema associated with query result. | Any Str | false |
| execution_status | Execution status of query being reported. | Any Str | false |
| error_message | Error message reported by query if present. | Any Str | false |
| query_type | Type of query performed. | Any Str | false |
| warehouse_name | Name of warehouse in query being reported on. | Any Str | false |
| database_name | Name of database being queried (default is snowflake). | Any Str | false |
| warehouse_size | Size of warehouse being reported on. | Any Str | false |

### snowflake.session_id.count

Distinct session id's associated with snowflake username over the last 24 hour window.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| 1 | Gauge | Int |

#### Attributes

| Name | Description | Values | Optional |
| ---- | ----------- | ------ | -------- |
| user_name | Username in query being reported. | Any Str | false |

### snowflake.storage.failsafe_bytes.total

Number of bytes of data in Fail-safe.

| Unit | Metric Type | Value Type |
| ---- | ----------- | ---------- |
| By | Gauge | Double |

## Resource Attributes

| Name | Description | Values | Enabled |
| ---- | ----------- | ------ | ------- |
| snowflake.account.name | Snowflake account being used by receiver. | Any Str | true |
